module Ruby
  module Terraform
    module Commands
      class OutputCommand
        include ExecutionSupport

        attr_accessor :dir
        attr_accessor :state
        attr_accessor :json
        attr_accessor :name

        def initialize(opts = {})
          @dir = opts[:dir]
          @state = opts[:state]
          @json = opts[:json]
          @name = opts[:name]
        end

        def command
          cmd = %W[#{tf_binary} output]

          cmd += ['-state', state] if state
          cmd += ['-json'] if json
          cmd += [name] if name
          cmd
        end
      end
    end
  end
end