module Ruby
  module Terraform
    class Configuration
      attr_accessor :terraform_version
      attr_accessor :download_path
      attr_accessor :binary

      def initialize(opts = {})
        @terraform_version = opts[:terraform_version]
        @download_path = opts[:download_path]
        @binary = opts[:terraform_binary]
      end

      def terraform_version
        @terraform_version ||= Ruby::Terraform::TERRAFORM_VERSION
      end

      def download_path
        @download_path ||= File.expand_path("~/.terraform-bin/#{terraform_version}")
      end

      def binary
        if @binary
          @binary
        elsif OS.windows?
          @binary ||= "#{@download_path}/terraform.exe"
        else
          @binary ||= "#{@download_path}/terraform"
        end
      end
    end
  end
end
