require 'zip'

module Ruby
  module Terraform
    class Decompressor
      class << self
        def extract(input_file, output_dir, verbose = false)
          Zip::File.open(input_file) do |zip_file|
            zip_file.each do |entry|
              dest_file = "#{output_dir}/#{entry.name}"
              $stderr.puts("Extracting to #{dest_file}") if verbose
              entry.extract(dest_file)
            end
          end
        end
      end
    end
  end
end