require 'rake/tasklib'

module Ruby
  module Terraform
    module Tasks
      class BaseTask < ::Rake::TaskLib
        # name of configuration
        attr_accessor :configuration_name

        # name of task
        attr_accessor :task_name

        # the working dir of `terraform` command
        attr_accessor :dir

        # the description of the task
        attr_accessor :description

        # should the terraform command be shown on the console. Defaults to `false`.
        attr_accessor :show_command

        # should the terraform output be shown on the console. Defaults to `false`.
        attr_accessor :show_output

        # the task dependencies
        attr_accessor :deps

        def initialize(configuration_name, task_name = nil)
          @configuration_name = configuration_name
          @task_name = task_name
          @deps = []

          if @task_name.is_a?(Hash)
            @deps = @task_name.values.first
            @task_name = @task_name.keys.first
          end

          yield self if block_given?
          define
        end
      end
    end
  end
end